#include "devXGD.h"
#include "xGDprot.h"

#include <stdio.h>
#include "sisocks.h"

/* FIXME: this should be probably handled by sisocks
          we need it for the TCP_NODELAY socket option */
#include <netinet/tcp.h>

void sendCMD(newXGDDesc *xd, unsigned int cmd, const void *par, unsigned int plen) {
  unsigned int hdr=cmd&0xff;
#ifdef XGD_DEBUG
  printf("XGD: sendCMD(%x, %x, %d)\n", cmd, par, plen);
#endif
  if (xd->sock==-1) return;
  if (plen>0xffff0) {
    unsigned int h[2];
    h[0]=(cmd & 0xff)|CMDA_LongPar;
    h[1]=plen >> 24;
    h[0]|=(plen&0xffffff)<<8;
    send(xd->sock, h, 8, 0);
  } else {
    hdr|=(plen << 8);
    send(xd->sock, &hdr, 4, 0);
  }
  if (par && plen>0)
    send(xd->sock, par, plen, 0);
}

int Xrecv(newXGDDesc *xd, void *wts, int len) {
  char *rb=(char*) wts;
  while (len>0) {
    int n=recv(xd->sock, rb, len, 0);
    if (n<1) {
#ifdef XGD_DEBUG
		if (!n)
			printf("XGD: ** connection closed by peer.\n");
		else
			printf("XGD: ** receive error encountered.\n");
#endif
      closesocket(xd->sock);
      xd->sock=-1;
      return n;
    }
    len-=n;
    rb+=n;
  }
  return 1;
}

void talkCMD(newXGDDesc *xd, int cmd, const void *par, int plen, void *res, int rlen) {
  unsigned int hdr, h2, xlen;
  int n;

#ifdef XGD_DEBUG
  printf("XGD: talkCMD(%x, %x, %d, %x, %d)\n", cmd, par, plen, res, rlen);
#endif
  if (xd->sock==-1) return;
  sendCMD(xd, cmd, par, plen);
  
  if (Xrecv(xd, &hdr, 4)!=1) return;
  xlen=hdr>>8;
  if ((hdr&CMDA_LongPar)>0) {
    if (Xrecv(xd, &h2, 4)!=1) return;
    xlen|=h2<<24;
  }
#ifdef XGD_DEBUG
  printf("XGD: Response: %x (%d bytes)\n",(hdr&0xff),xlen);
#endif
  if (xlen!=rlen)
    printf("XGD: -- Warning, expected %d bytes long response, got %d bytes.\n", rlen, xlen);
  if (xlen<rlen) rlen=xlen;
  n=Xrecv(xd, res, rlen);
  if (n!=1) return;
  if (xlen>rlen) {
    /* drop the rest - TODO!! */
  }
}

int connectXGD(newXGDDesc *xd, const char *host, int port) {
  SAIN sa;
  int opt=1;

  xd->sock = socket(AF_INET, SOCK_STREAM, 0);
  build_sin(&sa, host, port);
  setsockopt(xd->sock, IPPROTO_TCP, TCP_NODELAY, &opt, sizeof(opt));
  if (connect(xd->sock, (SA*)&sa, sizeof(sa))==-1) {
    closesocket(xd->sock);
    xd->sock=-1;
    printf("XGD: ** Unable to connect to %s:%d.\n",host,port);
    return -1;
  }

  int id[4] = { 0x58474431, 0x100, 0, 0 };
  
  send(xd->sock, &id, 16, 0);

  return 0;
}
